<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 5                                                    ***
  ***      File:  admin_fm_upload_files.php                                ***
  ***      Built: Tue Jun  6 16:19:04 2017                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/file_functions.php");
	include_once($root_folder_path . "includes/admin_fm_functions.php");
	include_once($root_folder_path . "includes/zip_class.php");
	include_once($root_folder_path . "messages/" . $language_code . "/download_messages.php");

	include_once("./admin_common.php");
	include_once("./admin_fm_config.php");

	check_admin_security("filemanager");

	$dir_root = check_dir_path(get_param("dir_root"));
	$error = check_dir_and_file($dir_root, "", "chmod");
	if (strlen($error)){
		set_session("fm_error",$error);
		header("Location: " . $host."admin_fm.php");
		exit;
	}
	
	$t = new VA_Template($settings["admin_templates_dir"]);
	
	$op = terminator(get_param("op"));

	if(strlen($op) == 0) {
		$op = 1;
	}
	
	if($op == 1) {
		$t->set_file("main","admin_fm_upload_files.html");
	}
	else {
		$t->set_file("main","admin_fm_upload_archive.html");		
	}
	$errors = "";
	$service_message = "";
	$select_errors = 0; // calculate number of missed files
	$tmp_dir = get_setting_value($settings, "tmp_dir", ""); 
	$tmpfname = uniqid("tmp"); // generate tmp folder name
	$tmp_dir_arch = $tmp_dir.$tmpfname;
	$t->set_var("dir_root", $dir_root);
	if(is_array($_FILES)) {
		foreach($_FILES as $key_file => $up_file) {

			$error = "";
			$tmp_name = $up_file["tmp_name"];
			$filename = terminator($up_file["name"]);
			$ext = strtolower(pathinfo($filename, PATHINFO_EXTENSION));
			$filesize = $up_file["size"];
			$upload_error = isset($up_file["error"]) ? $up_file["error"] : "";


			// 1. check general upload errors
			if ($upload_error == 1) {
				$error = FILESIZE_DIRECTIVE_ERROR_MSG;
			} elseif ($upload_error == 2) {
				$error = FILESIZE_PARAMETER_ERROR_MSG;
			} elseif ($upload_error == 3) {
				$error = PARTIAL_UPLOAD_ERROR_MSG;
			} elseif ($upload_error == 4) {
				$error = UPLOAD_SELECT_ERROR;
			} elseif ($upload_error == 6) {
				$error = TEMPORARY_FOLDER_ERROR_MSG;
			} elseif ($upload_error == 7) {
				$error = FILE_WRITE_ERROR_MSG;
			}

			// 2. check for other errors
			if (!$error) {	
				if ($op == 1 && !in_array($ext, $conf_array_files_ext)) { // check file extension for multi-upload
					$error = va_constant("INVALID_FILE_EXTENSION_MSG")." <b>".$filename."</b>";
				} else if ($op == 2 && !in_array($ext, $array_archive_file)) { // check file extension for arhive upload
					$error = va_constant("INVALID_FILE_EXTENSION_MSG")." <b>".$filename."</b>";
				} else if (!is_uploaded_file($tmp_name)) { // check if file was really uploaded
					$error = va_constant("NO_FILE_UPLOADED_MSG")." <b>".$filename."</b>";
				} else if (!@move_uploaded_file($tmp_name, $dir_root."/".$filename)) {
					if (!is_dir($dir_root)) {
						$error = va_constant("FOLDER_DOESNT_EXIST_MSG") . $dir_root;
					} elseif (!is_writable($dir_root)) {
						$error = str_replace("{folder_name}", $dir_root, va_constant("FOLDER_PERMISSION_MESSAGE"));
					} else {
						$error = va_constant("UPLOAD_CREATE_ERROR") ." <b>" . $dir_root . $filename . "</b>";
					}
				}
			}

			if ($error) {
				if ($upload_error == 4) {
					$select_errors++;
				}
				if ($upload_error != 4 || $select_errors == 6) {
					$errors .= $error."<br/>\n";	
				}
			} else {
				if ($op == 1) {
					$service_message .= va_constant("FILE_SAVED_MSG")." ".$filename."<br/>";
				} elseif($op == 2) {
					$array_files = array();

					$archive = new XPRAPTORZIP($dir_root."/".$filename);
					if ($archive->extract(XPrptrZIP_OPT_PATH, $tmp_dir_arch) != 0) {
						// prepare mask to check
						$ext_mask = "/(\.".implode("|\.", $conf_array_files_ext).")$/is";
						check_files_mask($tmp_dir_arch, "", $ext_mask, $files_matched, $files_mismatched);
						if (count($files_mismatched)) {
							foreach ($files_mismatched as $mismatched_file) {
								$errors .= va_constant("INVALID_FILE_EXTENSION_MSG")." <b>".$mismatched_file."</b><br/>\n";
							}
						} else {
							$archive->extract(XPrptrZIP_OPT_PATH, $dir_root);
							//$service_message .= str_replace("{filename}", $filename, va_constant("UPLOADED_FILE_MSG"));
							foreach ($files_matched as $matched_file) {
								$service_message .= va_constant("FILE_SAVED_MSG")." ".$dir_root."/".$matched_file."<br/>";
							}
						}
					} else {
						$errors = $archive->errorInfo(true);
					}
					rm($tmp_dir_arch); // remote tmp folder 
					unlink($dir_root."/".$filename); // remove archive file
				}
			}
		}
	}
	if (strlen($errors)) {
		$t->set_var("errors_list", $errors);
		$t->parse("errors_block", true);
	} else {
		$t->set_var("errors_block", "");
	}
	if(strlen($service_message) > 0) {
		$t->set_var("service_message", $service_message);
		$t->parse("service_messages", true);
	} else {
		$t->set_var("service_messages", "");
	}
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_upload_href", "admin_fm_upload_files.php");
	$t->set_var("admin_filemanager_href", "admin_fm.php");

	include_once("./admin_header.php");
	include_once("./admin_footer.php");
	$t->pparse("main");

?>