<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop 5                                                    ***
  ***      File:  db_upgrade.php                                           ***
  ***      Built: Tue Jun  6 16:19:04 2017                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$root_folder_path = ((isset($is_admin_path) && $is_admin_path) || (isset($is_sub_folder) && $is_sub_folder)) ? "../" : "./";
	include_once($root_folder_path."messages/".$language_code."/install_messages.php");

	// check if we already run this script during session
	$session_upgrade = get_session("session_upgrade");
	if ($session_upgrade) { return; }
	// run additional upgrade only for version 5.0
	if (comp_vers(va_version(), "5.0") != 0) { return; }

	if (!isset($message)) { $message = ""; } // save upgrade message here

	$sqls = array(); // array to save all queries to run

	// tables to delete: header_links

	// check for field update field
	$php_lib_field = false; $status_attachments = false;
	$show_for_affiliate = false; $show_for_merchant = false;
	$fields = $db->get_fields($table_prefix."order_statuses");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "status_php_lib") {
			$php_lib_field = true;
		} else if ($field_info["name"] == "mail_status_attachments") {
			$status_attachments = true;
		} else if ($field_info["name"] == "show_for_affiliate") {
			$show_for_affiliate = true;
		} else if ($field_info["name"] == "show_for_merchant") {
			$show_for_merchant = true;
		}
	}
	if (!$php_lib_field) {
		$sql = "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN status_php_lib VARCHAR(255) ";
		$sqls[] = $sql;
	}
	if (!$show_for_affiliate || !$show_for_merchant) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_affiliate TINYINT DEFAULT '0'",
			"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_affiliate SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_affiliate BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_merchant TINYINT DEFAULT '0'",
			"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_merchant SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN show_for_merchant BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = " UPDATE " . $table_prefix . "order_statuses SET show_for_merchant=show_for_user, show_for_affiliate=show_for_user ";
		$sqls[] = " UPDATE " . $table_prefix . "order_statuses SET show_for_user=1 ";
	}
	if (!$status_attachments) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_status_attachments TINYINT DEFAULT '0'",
			"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_status_attachments SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_status_attachments BYTE ",
		);
		$sqls[] = $sql_types[$db_type];

		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN admin_status_attachments TINYINT DEFAULT '0'",
			"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN admin_status_attachments SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN admin_status_attachments BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
	}
	// end field check

	// check allow_payment field in different tables
	$payment_allowed = false; $mail_to_field = false;
	$fields = $db->get_fields($table_prefix."order_statuses");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "payment_allowed") {
			$payment_allowed = true;
		} else if ($field_info["name"] == "mail_to") {
			$mail_to_field = true;
		}
	}
	if (!$mail_to_field) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN mail_to VARCHAR(255) ";
	}
	if (!$payment_allowed) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN payment_allowed TINYINT DEFAULT '0' AFTER allow_user_cancel ",
			"postgre" => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN payment_allowed SMALLINT DEFAULT '0' ",
			"access"  => "ALTER TABLE " . $table_prefix . "order_statuses ADD COLUMN payment_allowed BYTE ",
		);
		$sqls[] = $sql_types[$db_type];

		$sql = " SELECT status_id FROM " . $table_prefix . "order_statuses WHERE status_type='QUOTE_REQUEST' OR status_type='QUOTE' ";
		$db->query($sql);
		if (!$db->next_record()) {
			$sqls[] = "INSERT INTO ".$table_prefix."order_statuses (status_order,status_name,status_type,status_php_lib,admin_order_class,user_order_class,is_user_cancel,allow_user_cancel,payment_allowed,generate_invoice,user_invoice_activation,is_dispatch,is_list,show_for_user,paid_status,credit_note_action,stock_level_action,points_action,credit_action,commission_action,download_activation,download_notify,item_notify,mail_notify,mail_to,mail_from,mail_cc,mail_bcc,mail_reply_to,mail_return_path,mail_type,mail_pdf_invoice,mail_status_attachments,mail_subject,mail_body,sms_notify,sms_recipient,sms_originator,sms_message,merchant_notify,merchant_to,merchant_from,merchant_cc,merchant_bcc,merchant_reply_to,merchant_return_path,merchant_mail_type,merchant_subject,merchant_body,merchant_sms_notify,merchant_sms_recipient,merchant_sms_originator,merchant_sms_message,supplier_notify,supplier_to,supplier_from,supplier_cc,supplier_bcc,supplier_reply_to,supplier_return_path,supplier_mail_type,supplier_subject,supplier_body,supplier_sms_notify,supplier_sms_recipient,supplier_sms_originator,supplier_sms_message,affiliate_notify,affiliate_to,affiliate_from,affiliate_cc,affiliate_bcc,affiliate_reply_to,affiliate_return_path,affiliate_mail_type,affiliate_subject,affiliate_body,affiliate_sms_notify,affiliate_sms_recipient,affiliate_sms_originator,affiliate_sms_message,admin_notify,admin_to,admin_to_groups_ids,admin_from,admin_cc,admin_bcc,admin_reply_to,admin_return_path,admin_mail_type,admin_pdf_invoice,admin_status_attachments,admin_subject,admin_body,admin_sms_notify,admin_sms_recipient,admin_sms_originator,admin_sms_message,final_title,final_message,is_active,view_order_groups_all,view_order_groups_ids,set_status_groups_all,set_status_groups_ids,update_order_groups_all,update_order_groups_ids) VALUES (18 , 'STATUS_QUOTE_REQUEST_MSG' , 'QUOTE_REQUEST' , NULL , NULL , NULL , 0 , 0 , NULL , 0 , 0 , 0 , 1 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , 1 , 1 , NULL , 1 , NULL , 1 , NULL )" ;
		}

		$sql = " SELECT status_id FROM " . $table_prefix . "order_statuses WHERE status_type='PARTIALLY_PAID'";
		$db->query($sql);
		if (!$db->next_record()) {
			$sqls[] = "INSERT INTO ".$table_prefix."order_statuses (status_order,status_name,status_type,status_php_lib,admin_order_class,user_order_class,is_user_cancel,allow_user_cancel,payment_allowed,generate_invoice,user_invoice_activation,is_dispatch,is_list,show_for_user,paid_status,credit_note_action,stock_level_action,points_action,credit_action,commission_action,download_activation,download_notify,item_notify,mail_notify,mail_to,mail_from,mail_cc,mail_bcc,mail_reply_to,mail_return_path,mail_type,mail_pdf_invoice,mail_status_attachments,mail_subject,mail_body,sms_notify,sms_recipient,sms_originator,sms_message,merchant_notify,merchant_to,merchant_from,merchant_cc,merchant_bcc,merchant_reply_to,merchant_return_path,merchant_mail_type,merchant_subject,merchant_body,merchant_sms_notify,merchant_sms_recipient,merchant_sms_originator,merchant_sms_message,supplier_notify,supplier_to,supplier_from,supplier_cc,supplier_bcc,supplier_reply_to,supplier_return_path,supplier_mail_type,supplier_subject,supplier_body,supplier_sms_notify,supplier_sms_recipient,supplier_sms_originator,supplier_sms_message,affiliate_notify,affiliate_to,affiliate_from,affiliate_cc,affiliate_bcc,affiliate_reply_to,affiliate_return_path,affiliate_mail_type,affiliate_subject,affiliate_body,affiliate_sms_notify,affiliate_sms_recipient,affiliate_sms_originator,affiliate_sms_message,admin_notify,admin_to,admin_to_groups_ids,admin_from,admin_cc,admin_bcc,admin_reply_to,admin_return_path,admin_mail_type,admin_pdf_invoice,admin_status_attachments,admin_subject,admin_body,admin_sms_notify,admin_sms_recipient,admin_sms_originator,admin_sms_message,final_title,final_message,is_active,view_order_groups_all,view_order_groups_ids,set_status_groups_all,set_status_groups_ids,update_order_groups_all,update_order_groups_ids) VALUES (19 , 'STATUS_PARTIALLY_PAID_MSG' , 'PARTIALLY_PAID' , NULL , NULL , NULL , 0 , 0 , NULL , 1 , 1 , 0 , 1 , 1 , 0 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , 0 , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , 0 , NULL , NULL , NULL , NULL , NULL , 1 , 1 , NULL , 1 , NULL , 1 , NULL )";
		}
		$sqls[] = " UPDATE " . $table_prefix . "order_statuses SET payment_allowed=1 WHERE (paid_status=0 OR paid_status IS NULL) AND status_type<>'QUOTE_REQUEST' AND status_type<>'QUOTE' ";
	}

	$sql = " SELECT status_id FROM " . $table_prefix . "order_statuses WHERE status_type='QUOTE'";
	$db->query($sql);
	if ($db->next_record()) {
		$sqls[] = " UPDATE " . $table_prefix . "order_statuses SET status_type='QUOTE_REQUEST' WHERE status_type='QUOTE' ";
	}


	// check admin menu
	$admin_menu_id = "";
	$sql  = " SELECT menu_id FROM ".$table_prefix."menus ";
	$sql .= " WHERE menu_type=5 ";
	$admin_menu_id = get_db_value($sql);

	// get property_id and value_id properties for upgrade
	// get max property_id
	$sql = " SELECT MAX(property_id) FROM ".$table_prefix."cms_blocks_properties "; 
	$property_id = get_db_value($sql);
	// get max value_id
	$sql = " SELECT MAX(value_id) FROM ".$table_prefix."cms_blocks_values "; 
	$value_id = get_db_value($sql);

	// check for button options for products_latest, products_top_sellers, products_recently_viewed blocks
	$buttons_blocks = array();
	$sql  = " SELECT block_id,block_code FROM ".$table_prefix."cms_blocks "; 
	$sql .= " WHERE block_code='products_latest' "; 
	$sql .= " OR block_code='products_top_sellers' "; 
	$sql .= " OR block_code='products_recently_viewed' "; 
	$sql .= " OR block_code='products_related' "; 
	$sql .= " OR block_code='cart_recommended_products' "; 
	$sql .= " OR block_code='products_offers' "; 
	$db->query($sql);
	while ($db->next_record()) {
		$block_id = $db->f("block_id");
		$block_code = $db->f("block_code");
		$buttons_blocks[$block_code] = $block_id;
	}

	// save some ids for further checks
	$top_sellers_block_id = isset($buttons_blocks["products_top_sellers"]) ? $buttons_blocks["products_top_sellers"] : "";
	$products_latest_block_id = isset($buttons_blocks["products_latest"]) ? $buttons_blocks["products_latest"] : "";
	$products_offers_block_id = isset($buttons_blocks["products_offers"]) ? $buttons_blocks["products_offers"] : "";

	// check if button was added
	foreach ($buttons_blocks as $block_code => $block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='bn_add' "; 
		$sql .= " AND block_id=" . $db->tosql($block_id, INTEGER); 
		$db->query($sql);
		if ($db->next_record()) {
			unset($buttons_blocks[$block_code]);
		}
		// check number of columns for top sellers block
		if ($block_code == "products_top_sellers") {
			$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
			$sql .= " WHERE variable_name='cols' "; 
			$sql .= " AND block_id=" . $db->tosql($block_id, INTEGER); 
			$db->query($sql);
			if (!$db->next_record()) {
				$property_id++; 
				$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $block_id, 1, 'NUMBER_OF_COLUMNS_MSG', 'TEXTBOX', NULL, NULL, 'cols', '1', 0)";
			}
		}
	}

	// add buttons where is there is no any properties yet
	foreach ($buttons_blocks as $block_code => $block_id) {
		$sql  = " DELETE FROM ".$table_prefix."cms_blocks_properties ";
		$sql .= " WHERE variable_name IN ('bn_add','bn_view','bn_goto','bn_wish','bn_more') "; 
		$sql .= " AND block_id=" . $db->tosql($block_id, INTEGER); 
		
		// get max property_order for latest block
		$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE block_id=" . $db->tosql($block_id, INTEGER); 
		$property_order = get_db_value($sql);

		// add 'add to cart' button option
		// check if property with different name exists
		$add_property_id = ""; 
		if ($block_code == "products_offers") {
			$sql = " SELECT property_id FROM " .$table_prefix."cms_blocks_properties "; 
			$sql.= " WHERE block_id=".$db->tosql($block_id, INTEGER);
			$sql.= " AND variable_name='prod_offers_add_button' ";
			$db->query($sql);
			if ($db->next_record()) {
				$add_property_id = $db->f("property_id"); 
			}
		}
		if ($add_property_id) {
			$sql  = " UPDATE " .$table_prefix."cms_blocks_properties ";
			$sql .= " SET control_type='RADIOBUTTON', variable_name='bn_add', default_value='1' ";
			$sql .= " WHERE property_id=".$db->tosql($add_property_id, INTEGER);
			$db->query($sql);

			$sql  = " UPDATE " .$table_prefix."cms_blocks_settings ";
			$sql .= " SET variable_name='bn_add' ";
			$sql .= " WHERE variable_name='prod_offers_add_button' AND property_id=".$db->tosql($add_property_id, INTEGER);
			$db->query($sql);

			$sql  = " DELETE FROM " . $table_prefix . "cms_blocks_values ";
			$sql .= " WHERE property_id=".$db->tosql($add_property_id, INTEGER);
			$db->query($sql);
		} else {
			$property_id++; $property_order++;
			$add_property_id = $property_id;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($add_property_id, $block_id, $property_order, 'ADD_TO_CART_MSG', 'RADIOBUTTON', NULL, NULL, 'bn_add', '1', 0)";
		}
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($add_property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($add_property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	

		// add 'VIEW_CART_MSG' button option
		// check if property with different name exists
		$view_property_id = ""; 
		if ($block_code == "products_offers") {
			$sql = " SELECT property_id FROM " .$table_prefix."cms_blocks_properties "; 
			$sql.= " WHERE block_id=".$db->tosql($block_id, INTEGER);
			$sql.= " AND variable_name='prod_offers_view_button' ";
			$db->query($sql);
			if ($db->next_record()) {
				$view_property_id = $db->f("property_id"); 
			}
		}
		if ($view_property_id) {
			$sql  = " UPDATE " .$table_prefix."cms_blocks_properties ";
			$sql .= " SET control_type='RADIOBUTTON', variable_name='bn_view', default_value='0' ";
			$sql .= " WHERE property_id=".$db->tosql($view_property_id, INTEGER);
			$db->query($sql);

			$sql  = " UPDATE " .$table_prefix."cms_blocks_settings ";
			$sql .= " SET variable_name='bn_view' ";
			$sql .= " WHERE variable_name='prod_offers_view_button' AND property_id=".$db->tosql($view_property_id, INTEGER);
			$db->query($sql);

			$sql  = " DELETE FROM " . $table_prefix . "cms_blocks_values ";
			$sql .= " WHERE property_id=".$db->tosql($view_property_id, INTEGER);
			$db->query($sql);
		} else {
			$property_id++; $property_order++;
			$view_property_id = $property_id;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $block_id, $property_order, 'VIEW_CART_MSG', 'RADIOBUTTON', NULL, NULL, 'bn_view', '0', 0)";
		}

		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($view_property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($view_property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	

		// add 'Checkout' button option
		// check if property with different name exists
		$goto_property_id = ""; 
		if ($block_code == "products_offers") {
			$sql = " SELECT property_id FROM " .$table_prefix."cms_blocks_properties "; 
			$sql.= " WHERE block_id=".$db->tosql($block_id, INTEGER);
			$sql.= " AND variable_name='prod_offers_goto_button' ";
			$db->query($sql);
			if ($db->next_record()) {
				$goto_property_id = $db->f("property_id"); 
			}
		}
		if ($goto_property_id) {
			$sql  = " UPDATE " .$table_prefix."cms_blocks_properties SET control_type='RADIOBUTTON', variable_name='bn_goto', default_value='0' ";
			$sql .= " WHERE property_id=".$db->tosql($goto_property_id, INTEGER);
			$db->query($sql);
			$sql  = " UPDATE " .$table_prefix."cms_blocks_settings ";
			$sql .= " SET variable_name='bn_goto' ";
			$sql .= " WHERE variable_name='prod_offers_goto_button' AND property_id=".$db->tosql($goto_property_id, INTEGER);
			$db->query($sql);
			$sql  = " DELETE FROM " . $table_prefix . "cms_blocks_values WHERE property_id=".$db->tosql($goto_property_id, INTEGER);
			$db->query($sql);
		} else {
			$property_id++; $property_order++;
			$goto_property_id = $property_id;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $block_id, $property_order, 'GOTO_CHECKOUT_MSG', 'RADIOBUTTON', NULL, NULL, 'bn_goto', '0', 0)";
		}

		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($goto_property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($goto_property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	

		// add 'Wishlist' button option
		// check if property with different name exists
		$wish_property_id = ""; 
		if ($block_code == "products_offers") {
			$sql = " SELECT property_id FROM " .$table_prefix."cms_blocks_properties "; 
			$sql.= " WHERE block_id=".$db->tosql($block_id, INTEGER);
			$sql.= " AND variable_name='prod_offers_wish_button' ";
			$db->query($sql);
			if ($db->next_record()) {
				$wish_property_id = $db->f("property_id"); 
			}
		}
		if ($wish_property_id) {
			$sql  = " UPDATE " .$table_prefix."cms_blocks_properties SET control_type='RADIOBUTTON', variable_name='bn_wish', default_value='0' ";
			$sql .= " WHERE property_id=".$db->tosql($wish_property_id, INTEGER);
			$db->query($sql);
			$sql  = " UPDATE " .$table_prefix."cms_blocks_settings ";
			$sql .= " SET variable_name='bn_wish' ";
			$sql .= " WHERE variable_name='prod_offers_wish_button' AND property_id=".$db->tosql($wish_property_id, INTEGER);
			$db->query($sql);
			$sql  = " DELETE FROM " . $table_prefix . "cms_blocks_values WHERE property_id=".$db->tosql($wish_property_id, INTEGER);
			$db->query($sql);
		} else {
			$property_id++; $property_order++;
			$wish_property_id = $property_id;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $block_id, $property_order, 'WISHLIST_MSG', 'RADIOBUTTON', NULL, NULL, 'bn_wish', '0', 0)";
		}
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($wish_property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($wish_property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	

		// add 'Read more' button option
		$property_id++; $property_order++;
		$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $block_id, $property_order, 'READ_MORE_MSG', 'RADIOBUTTON', NULL, NULL, 'bn_more', '0', 0)";
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	
	}

	// check for new max_recs parameter for products latest block
	$latest_block_id = ""; 
	$sql  = " SELECT block_id FROM ".$table_prefix."cms_blocks "; 
	$sql .= " WHERE block_code='products_latest' "; 
	$latest_block_id = get_db_value($sql);
	if ($latest_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='max_recs' "; 
		$sql .= " AND block_id=" . $db->tosql($latest_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			$property_id++; 
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $latest_block_id, 1, 'MAXIMUM_RECORDS_MSG', 'TEXTBOX', NULL, NULL, 'max_recs', NULL, 0)";
		}
		// check for nav_pages variable 
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='nav_pages' "; 
		$sql .= " AND block_id=" . $db->tosql($latest_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			$property_id++; 

			$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
			$sql .= " WHERE block_id=".$db->tosql($latest_block_id, INTEGER); 
			$property_order = get_db_value($sql);
			$property_order++;

			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $latest_block_id, $property_order, 'NUMBER_OF_PAGES_NAVIGATOR_MSG', 'TEXTBOX', NULL, NULL, 'nav_pages', '10', 0)";
		}

	}

	// check for new categories type option
	$prodcat_block_id = ""; $prodcat_property_id = "";
	$sql  = " SELECT block_id,block_code FROM ".$table_prefix."cms_blocks "; 
	$sql .= " WHERE block_code='categories_list' "; 
	$db->query($sql);
	if ($db->next_record()) {
		$prodcat_block_id = $db->f("block_id");
	}
	if ($prodcat_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='categories_type' "; 
		$sql .= " AND block_id=" . $db->tosql($prodcat_block_id, INTEGER); 
		$db->query($sql);
		if ($db->next_record()) {
			$prodcat_property_id = $db->f("property_id");
		}
	}
	if ($prodcat_property_id) {
		$sql  = " SELECT value_id FROM ".$table_prefix."cms_blocks_values "; 
		$sql .= " WHERE variable_value='7' "; 
		$sql .= " AND property_id=" . $db->tosql($prodcat_property_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($prodcat_property_id).", 7, 'SUBCATEGORIES_POPUP_MSG', '', '7') ";
			$sqls[] = $sql;	
		}
	}


	// check random image option for products list block
	$prodlist_block_id = ""; $img_rnd_property_id = "";
	$sql  = " SELECT block_id FROM ".$table_prefix."cms_blocks "; 
	$sql .= " WHERE block_code='products_list' "; 
	$db->query($sql);
	if ($db->next_record()) {
		$prodlist_block_id = $db->f("block_id");
	}
	if ($prodlist_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='random_image' "; 
		$sql .= " AND block_id=" . $db->tosql($prodlist_block_id, INTEGER); 
		$db->query($sql);
		if ($db->next_record()) {
			$img_rnd_property_id = $db->f("property_id");
		}
	}
	if ($prodlist_block_id && !$img_rnd_property_id) {
		// get max property_order for latest block
		$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE block_id=" . $db->tosql($prodlist_block_id, INTEGER); 
		$property_order = get_db_value($sql);

		// add 'Read more' button option
		$property_id++; $property_order++;
		$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,required) VALUES ($property_id, $prodlist_block_id, $property_order, 'RANDOM_IMAGE_MSG', 'RADIOBUTTON', NULL, NULL, 'random_image', 0)";
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($property_id).", 1, 'YES_MSG', '', '1') ";
		$sqls[] = $sql;	
		$value_id++;
		$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
		$sql .= intval($value_id).",".intval($property_id).", 2, 'NO_MSG', '', '0') ";
		$sqls[] = $sql;	
	}


	// check for new table creation
  $tables = $db->get_tables();
	$orders_attachments = false; $shipping_companies = false; $authors_languages = false; $conditions_table = false;
	foreach ($tables as $table_id => $table_name) {
		if ($table_name == $table_prefix."orders_attachments") {
			$orders_attachments = true;
		} else if ($table_name == $table_prefix."shipping_companies") {
			$shipping_companies = true;
		} else if ($table_name == $table_prefix."authors_languages") {
			$authors_languages = true;
		} else if ($table_name == $table_prefix."conditions") {
			$conditions_table = true;
		}
	}

	if (!$orders_attachments) {
		if ($db_type == "mysql") {
			$sqls[] = "CREATE TABLE ".$table_prefix."orders_attachments (
        `attachment_id` INT(11) NOT NULL AUTO_INCREMENT,
        `order_id` INT(11) default '0',
        `event_id` INT(11) default '0',
        `admin_id` INT(11) default '0',
        `user_id` INT(11) default '0',
        `show_for_user` TINYINT default '1',
        `attachment_type` TINYINT default '1',
        `file_path` VARCHAR(255),
        `file_name` VARCHAR(255),
        `date_added` DATETIME
        ,KEY admin_id (admin_id)
        ,KEY event_id (event_id)
        ,KEY order_id (order_id)
        ,PRIMARY KEY (attachment_id)
        ,KEY user_id (user_id)
				) DEFAULT CHARACTER SET=utf8";
		} else if ($db_type == "postgre") {
			$sqls[] = "CREATE SEQUENCE seq_".$table_prefix."orders_attachments START 1";
			$sqls[] = "CREATE TABLE ".$table_prefix."orders_attachments (
        attachment_id INT4 NOT NULL DEFAULT nextval('seq_".$table_prefix."orders_attachments'),
        order_id INT4 default '0',
        event_id INT4 default '0',
        admin_id INT4 default '0',
        user_id INT4 default '0',
        show_for_user SMALLINT default '1',
        attachment_type SMALLINT default '1',
        file_path VARCHAR(255),
        file_name VARCHAR(255),
        date_added TIMESTAMP
        ,PRIMARY KEY (attachment_id))";
		} else if ($db_type == "access") {
			$sqls[] = "CREATE TABLE ".$table_prefix."orders_attachments (
        [attachment_id]  COUNTER  NOT NULL,
        [order_id] INTEGER,
        [event_id] INTEGER,
        [admin_id] INTEGER,
        [user_id] INTEGER,
        [show_for_user] BYTE,
        [attachment_type] BYTE,
        [file_path] VARCHAR(255),
        [file_name] VARCHAR(255),
        [date_added] DATETIME
        ,PRIMARY KEY (attachment_id))";
		} 
		if ($db_type != "mysql") {
			$sqls[] = "CREATE INDEX ".$table_prefix."orders_attachments_admin_id ON ".$table_prefix."orders_attachments (admin_id)";
			$sqls[] = "CREATE INDEX ".$table_prefix."orders_attachments_event_id ON ".$table_prefix."orders_attachments (event_id)";
			$sqls[] = "CREATE INDEX ".$table_prefix."orders_attachments_order_id ON ".$table_prefix."orders_attachments (order_id)";
			$sqls[] = "CREATE INDEX ".$table_prefix."orders_attachments_user_id ON ".$table_prefix."orders_attachments (user_id)";
		}
	}

	if (!$shipping_companies) {
		if ($db_type == "mysql") {
			$sqls[] = "CREATE TABLE ".$table_prefix."shipping_companies (
        `shipping_company_id` INT(11) NOT NULL AUTO_INCREMENT,
        `company_name` VARCHAR(255),
        `company_url` VARCHAR(255),
        `image_small` VARCHAR(255),
        `image_large` VARCHAR(255),
        `short_description` TEXT,
        `full_description` TEXT
        ,PRIMARY KEY (shipping_company_id)
        ) DEFAULT CHARACTER SET=utf8 ";
		} else if ($db_type == "postgre") {
			$sqls[] = "CREATE SEQUENCE seq_".$table_prefix."shipping_companies START 1";
			$sqls[] = "CREATE TABLE ".$table_prefix."shipping_companies (
        shipping_company_id INT4 NOT NULL DEFAULT nextval('seq_".$table_prefix."shipping_companies'),
        company_name VARCHAR(255),
        company_url VARCHAR(255),
        image_small VARCHAR(255),
        image_large VARCHAR(255),
        short_description TEXT,
        full_description TEXT
        ,PRIMARY KEY (shipping_company_id))";
		} else if ($db_type == "access") {
			$sqls[] = "CREATE TABLE ".$table_prefix."shipping_companies (
        [shipping_company_id]  COUNTER  NOT NULL,
        [company_name] VARCHAR(255),
        [company_url] VARCHAR(255),
        [image_small] VARCHAR(255),
        [image_large] VARCHAR(255),
        [short_description] LONGTEXT,
        [full_description] LONGTEXT
        ,PRIMARY KEY (shipping_company_id))";
		} 
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN shipping_company_id INT(11) ",
			"postgre" => "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN shipping_company_id INT4  ",
			"access"  => "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN shipping_company_id INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
	}

	if (!$conditions_table) {
		if ($db_type == "mysql") {
			$sqls[] = "CREATE TABLE ".$table_prefix."conditions (
        `condition_id` INT(11) NOT NULL AUTO_INCREMENT,
        `condition_name` VARCHAR(50),
        `sort_order` VARCHAR(50)
        ,PRIMARY KEY (condition_id)
        ) DEFAULT CHARACTER SET=utf8 ";
		} else if ($db_type == "postgre") {
			$sqls[] = "CREATE SEQUENCE seq_".$table_prefix."conditions START 1";
			$sqls[] = "CREATE TABLE ".$table_prefix."conditions (
        condition_id INT4 NOT NULL DEFAULT nextval('seq_".$table_prefix."conditions'),
        condition_name VARCHAR(50),
        sort_order VARCHAR(50)
        ,PRIMARY KEY (condition_id))";
		} else if ($db_type == "access") {
			$sqls[] = "CREATE TABLE ".$table_prefix."conditions (
        [condition_id]  COUNTER  NOT NULL,
        [condition_name] VARCHAR(50),
        [sort_order] VARCHAR(50)
        ,PRIMARY KEY (condition_id))";
		} 
	}

	// check orders settings menu
	if ($admin_menu_id) {
		$sql  = " SELECT menu_item_id ";
		$sql .= " FROM ".$table_prefix."menus_items ";
		$sql .= " WHERE menu_id=".$db->tosql($admin_menu_id, INTEGER);
		$sql .= " AND menu_code='orders-settings' ";
	  $orders_settings_id = get_db_value($sql);

		if ($orders_settings_id) {
			$sql  = " SELECT menu_item_id ";
			$sql .= " FROM ".$table_prefix."menus_items ";
			$sql .= " WHERE menu_id=".$db->tosql($admin_menu_id, INTEGER);
			$sql .= " AND menu_code='shipping-companies' ";
		  $shipping_companies_id = get_db_value($sql);
			if (!$shipping_companies_id) {
				$sqls[] = " UPDATE " . $table_prefix . "menus_items SET menu_order=menu_order+1 WHERE menu_order>=3 AND parent_menu_item_id=".$db->tosql($orders_settings_id, INTEGER);

				$sql  = "INSERT INTO " . $table_prefix . "menus_items (menu_id,parent_menu_item_id,menu_order,menu_title,menu_url,menu_code,admin_access) VALUES (";
				$sql .= intval($admin_menu_id).",".intval($orders_settings_id).", 3, 'SHIPPING_COMPANIES_MSG', 'admin_shipping_companies.php', 'shipping-companies', 'all') ";
				$sqls[] = $sql;	
			}
		}
	}

	// check for hide fields update in items table
	$fields = $db->get_fields($table_prefix."items");
	$hide_fields = array(
		"hide_view_list" => false, "hide_view_details" => false, "hide_view_table" => false, "hide_view_grid" => false,
		"hide_checkout_list" => false, "hide_checkout_details" => false, "hide_checkout_table" => false, "hide_checkout_grid" => false,
		"hide_wishlist_list" => false, "hide_wishlist_details" => false, "hide_wishlist_table" => false, "hide_wishlist_grid" => false,
		"hide_more_list" => false, "hide_more_table" => false, "hide_more_grid" => false,
		"hide_free_shipping_list" => false, "hide_free_shipping_table" => false, "hide_free_shipping_grid" => false, "hide_free_shipping_details" => false,
		"hide_shipping_details" => false,
	);

	foreach ($fields as $id => $field_info) {
		$field_name = $field_info["name"];
		if (isset($hide_fields[$field_name])) {
			$hide_fields[$field_name] = true;
		}
	}
	foreach ($hide_fields as $field_name => $field_exists) {
		if (!$field_exists) {
			if ($db->DBType == "mysql") {
				$sql = "ALTER TABLE ".$table_prefix."items ADD COLUMN ".$field_name." TINYINT ";
			} else if ($db->DBType == "access") {
				$sql = "ALTER TABLE ".$table_prefix."items ADD COLUMN ".$field_name." SMALLINT ";
			} else {
				$sql = "ALTER TABLE ".$table_prefix."items ADD COLUMN ".$field_name." BYTE ";
			}
			$sqls[] = $sql;	
		}
	}
	// end field check

	// check actual_weight field in different tables and condition field in items table
	$actual_weight_field = false; $condition_field = false; 
	$fields = $db->get_fields($table_prefix."items");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		} else if ($field_info["name"] == "condition_id") {
			$condition_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN actual_weight DOUBLE(16,4) AFTER weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "items ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$condition_field) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "items ADD COLUMN condition_id INT(11) ",
			"postgre" => "ALTER TABLE " . $table_prefix . "items ADD COLUMN condition_id INT4  ",
			"access"  => "ALTER TABLE " . $table_prefix . "items ADD COLUMN condition_id INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."items_properties_values");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN actual_weight DOUBLE(16,4) AFTER additional_weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "items_properties_values ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."order_custom_values");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "order_custom_values ADD COLUMN actual_weight DOUBLE(16,4) AFTER property_weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "order_custom_values ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "order_custom_values ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$orders_middle_name = false; $orders_address3 = false;
	$orders_shipped_date = false;
	$fields = $db->get_fields($table_prefix."orders");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight_total") {
			$actual_weight_field = true;
		} else if ($field_info["name"] == "middle_name") {
			$orders_middle_name = true;
		} else if ($field_info["name"] == "address3") {
			$orders_address3 = true;
		} else if ($field_info["name"] == "order_shipped_date") {
			$orders_shipped_date = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN actual_weight_total DOUBLE(16,4) AFTER weight_total ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "orders ADD COLUMN actual_weight_total FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN actual_weight_total FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$orders_middle_name) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN middle_name VARCHAR(64) AFTER first_name ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN delivery_middle_name VARCHAR(64) AFTER delivery_first_name ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN bill_middle_name VARCHAR(64) AFTER bill_first_name ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN middle_name VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN delivery_middle_name VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN bill_middle_name VARCHAR(64) ";
		}
	}
	if (!$orders_address3) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN address3 VARCHAR(64) AFTER address2 ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN delivery_address3 VARCHAR(64) AFTER address2 ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN bill_address3 VARCHAR(64) AFTER address2 ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN address3 VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN delivery_address3 VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "orders ADD COLUMN bill_address3 VARCHAR(64) ";
		}
	}
	if (!$orders_shipped_date) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN order_shipped_date DATETIME AFTER order_paid_date ",
			"postgre" => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN order_shipped_date TIMESTAMP ",
			"access"  => "ALTER TABLE " . $table_prefix . "orders ADD COLUMN order_shipped_date DATETIME ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = "CREATE INDEX ".$table_prefix."orders_order_shipped_date ON ".$table_prefix."orders (order_shipped_date)";
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."orders_items");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN actual_weight DOUBLE(16,4) AFTER weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "orders_items ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."orders_items_properties");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN actual_weight DOUBLE(16,4) AFTER additional_weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "orders_items_properties ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."orders_properties");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "orders_properties ADD COLUMN actual_weight DOUBLE(16,4) AFTER property_weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "orders_properties ADD COLUMN actual_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "orders_properties ADD COLUMN actual_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}

	$actual_weight_field = false; 
	$fields = $db->get_fields($table_prefix."orders_shipments");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "actual_goods_weight") {
			$actual_weight_field = true;
		}
	}
	if (!$actual_weight_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN actual_goods_weight DOUBLE(16,4) AFTER goods_weight ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN actual_goods_weight FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "orders_shipments ADD COLUMN actual_goods_weight FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}


	if (!$authors_languages) {
		if ($db_type == "mysql") {
			$sqls[] = "CREATE TABLE ".$table_prefix."authors_languages (
        `author_id` INT(11) NOT NULL default '0',
        `language_code` VARCHAR(2) NOT NULL
        ,PRIMARY KEY (author_id,language_code)
				) DEFAULT CHARACTER SET=utf8";
		} else if ($db_type == "postgre") {
			$sqls[] = "CREATE TABLE ".$table_prefix."authors_languages (
        author_id INT4 NOT NULL default '0',
        language_code VARCHAR(2) NOT NULL
        ,PRIMARY KEY (author_id,language_code))";
		} else if ($db_type == "access") {
			$sqls[] = "CREATE TABLE ".$table_prefix."authors_languages (
        [author_id] INTEGER NOT NULL,
        [language_code] VARCHAR(2) NOT NULL
        ,PRIMARY KEY (author_id,language_code))";
		} 
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN languages_all TINYINT NOT NULL DEFAULT '1'",
			"postgre" => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN languages_all SMALLINT NOT NULL DEFAULT '1'",
			"access"  => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN languages_all BYTE NOT NULL ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = " UPDATE " . $table_prefix . "authors SET languages_all=1 ";
	}

	$extra_name_field = false; 
	$fields = $db->get_fields($table_prefix."authors");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "extra_name") {
			$extra_name_field = true;
		}
	}
	
	if (!$extra_name_field) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN extra_name VARCHAR(64) ";
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN name_second VARCHAR(2) ";
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN other_second VARCHAR(2) ";
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN extra_first VARCHAR(2) ";
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN extra_second VARCHAR(2) ";
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN author_country_id INT(11) ",
			"postgre" => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN author_country_id INT4  ",
			"access"  => "ALTER TABLE " . $table_prefix . "authors ADD COLUMN author_country_id INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = "ALTER TABLE " . $table_prefix . "authors ADD COLUMN author_country_code VARCHAR(4) ";

		$sqls[] = "CREATE INDEX ".$table_prefix."authors_name_second ON ".$table_prefix."authors (name_second)";
		$sqls[] = "CREATE INDEX ".$table_prefix."authors_other_second ON ".$table_prefix."authors (other_second)";
		$sqls[] = "CREATE INDEX ".$table_prefix."authors_extra_first ON ".$table_prefix."authors (extra_first)";
		$sqls[] = "CREATE INDEX ".$table_prefix."authors_extra_second ON ".$table_prefix."authors (extra_second)";
		$sqls[] = "CREATE INDEX ".$table_prefix."authors_author_country_id ON ".$table_prefix."authors (author_country_id)";
		$sqls[] = "CREATE INDEX ".$table_prefix."authors_author_country_code ON ".$table_prefix."authors (author_country_code)";
	}

	// check for field update field
	$menu_code_field = false; 
	$fields = $db->get_fields($table_prefix."menus");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "menu_code") {
			$menu_code_field = true;
		}
	}
	if (!$menu_code_field) {
		$sql = "ALTER TABLE " . $table_prefix . "menus ADD COLUMN menu_code VARCHAR(64) ";
		$sqls[] = $sql;
	}

	// add right column menu if it wasn't added
	$sql = "SELECT layout_id FROM ".$table_prefix."cms_layouts WHERE layout_template='layout_right.html' ";
	$db->query($sql);
	if (!$db->next_record()) {

		$sql = " SELECT MAX(layout_id) FROM ".$table_prefix."cms_layouts "; 
		$layout_id = get_db_value($sql);
		$layout_id++;

		$sql  = " INSERT INTO ".$table_prefix."cms_layouts ";
		$sql .= " (layout_id, layout_name, layout_order, layout_template, admin_template) VALUES (".intval($layout_id).", 'RIGHT_COLUMN_LAYOUT_MSG', 6, 'layout_right.html', 'admin_layout_right.html')";
		$sqls[] = $sql;

		$sqls[] = "INSERT INTO ".$table_prefix."cms_frames (layout_id,frame_name,tag_name) VALUES (".intval($layout_id).", 'HEADER_MSG' , 'header' )";
		$sqls[] = "INSERT INTO ".$table_prefix."cms_frames (layout_id,frame_name,tag_name) VALUES (".intval($layout_id).", 'MIDDLE_COLUMN_MSG' , 'middle')";
		$sqls[] = "INSERT INTO ".$table_prefix."cms_frames (layout_id,frame_name,tag_name) VALUES (".intval($layout_id).", 'RIGHT_COLUMN_MSG' , 'right')";
		$sqls[] = "INSERT INTO ".$table_prefix."cms_frames (layout_id,frame_name,tag_name) VALUES (".intval($layout_id).", 'FOOTER_MSG' , 'footer')";
	} else {
		$right_layout_id = $db->f("layout_id");
		$sql = "SELECT layout_id FROM ".$table_prefix."cms_frames WHERE tag_name='frame_bar' AND layout_id=" . $db->tosql($right_layout_id, INTEGER);
		$db->query($sql);
		if (!$db->next_record()) {
			$sqls[] = "INSERT INTO ".$table_prefix."cms_frames (layout_id,frame_name,tag_name) VALUES (".intval($right_layout_id).", 'NAVIGATION_BAR_MSG' , 'frame_bar')";
		}
	}

	$sql = " SELECT COUNT(*) FROM ".$table_prefix . "sites WHERE short_name IS NULL OR short_name='' ";
	$empty_short_names = get_db_value($sql);
	if ($empty_short_names) {
		$sqls[] = " UPDATE " . $table_prefix . "sites SET short_name=site_name WHERE short_name IS NULL OR short_name=''  ";
	}

	// new range settings for top seller block if doesn't exists
	if ($top_sellers_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='categories_range' "; 
		$sql .= " AND block_id=" . $db->tosql($top_sellers_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			// get max property_order for latest block
			$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
			$sql .= " WHERE block_id=" . $db->tosql($top_sellers_block_id, INTEGER); 
			$property_order = get_db_value($sql);

			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,required) VALUES ($property_id, $top_sellers_block_id, $property_order, 'CATEGORIES_RANGE_MSG', 'LISTBOX', 'categories_range', 0)";
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($property_id).", 1, 'ALL_CATEGORIES_RANGE_MSG', 'all') ";
			$sqls[] = $sql;	
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($property_id).", 2, 'ACTIVE_CATEGORY_RANGE_MSG', 'active') ";
			$sqls[] = $sql;	
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($property_id).", 3, 'CATEGORY_SUBS_RANGE_MSG', 'subs') ";
			$sqls[] = $sql;	
		}
	}

	// new settings for products latest block
	if ($products_latest_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='period_days' "; 
		$sql .= " AND block_id=" . $db->tosql($products_latest_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			// get max property_order for latest block
			$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
			$sql .= " WHERE block_id=" . $db->tosql($products_latest_block_id, INTEGER); 
			$property_order = get_db_value($sql);

			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,end_html,required) VALUES ($property_id, $products_latest_block_id, $property_order, 'TIME_PERIOD_MSG', 'TEXTBOX', 'period_days', ' {DAYS_MSG}', 0)";
		}
	}

	// new range settings for top seller block if doesn't exists
	if ($products_offers_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='slider_column_width' "; 
		$sql .= " AND block_id=" . $db->tosql($products_offers_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			$property_id++; 
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,required) VALUES ($property_id, $products_offers_block_id, 11, 'COLUMN_WIDTH_MSG', 'TEXTBOX', 'slider_column_width', 0)";
		}
	}

	// check random image option for products list block
	$prod_details_block_id = ""; 
	$sql  = " SELECT block_id FROM ".$table_prefix."cms_blocks "; 
	$sql .= " WHERE block_code='product_details' "; 
	$db->query($sql);
	if ($db->next_record()) {
		$prod_details_block_id = $db->f("block_id");
	}
	if ($prod_details_block_id) {
		$sql  = " SELECT property_id FROM ".$table_prefix."cms_blocks_properties "; 
		$sql .= " WHERE variable_name='accessories_cols' "; 
		$sql .= " AND block_id=" . $db->tosql($prod_details_block_id, INTEGER); 
		$db->query($sql);
		if (!$db->next_record()) {
			// get max property_order for latest block
			$sql  = " SELECT MAX(property_order) FROM ".$table_prefix."cms_blocks_properties "; 
			$sql .= " WHERE block_id=" . $db->tosql($prod_details_block_id, INTEGER); 
			$property_order = get_db_value($sql);

			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,required) VALUES ($property_id, $prod_details_block_id, $property_order, '{PROD_ACCESSORIES_MSG}: {NUMBER_OF_COLUMNS_MSG}', 'TEXTBOX', 'accessories_cols', 0)";

			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,required) VALUES ($property_id, $prod_details_block_id, $property_order, '{PROD_ACCESSORIES_MSG}: {IMAGE_TYPE_MSG}', 'LISTBOX', 'accessories_image_type', 0)";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 1, 'DONT_SHOW_IMAGE_MSG', 'no') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 2, 'IMAGE_TINY_MSG', 'tiny') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 3, 'IMAGE_SMALL_MSG', 'small') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 4, 'IMAGE_LARGE_MSG', 'large') ";

			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,variable_name,required) VALUES ($property_id, $prod_details_block_id, $property_order, '{PROD_ACCESSORIES_MSG}: {DESCRIPTION_MSG}', 'LISTBOX', 'accessories_desc', 0)";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 1, 'DONT_SHOW_DESC_MSG', 'no') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 2, 'SHORT_DESCRIPTION_MSG', 'short') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 3, 'FULL_DESCRIPTION_MSG', 'full') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 4, 'HIGHLIGHTS_MSG', 'high') ";
			$value_id++;
			$sqls[] = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_value) VALUES (".intval($value_id).",".intval($property_id).", 5, 'SPECIAL_OFFER_MSG', 'spec') ";

			// add 'Read more' button option
			$property_id++; $property_order++;
			$sqls[] ="INSERT INTO " .$table_prefix."cms_blocks_properties (property_id,block_id,property_order,property_name,control_type,parent_property_id,parent_value_id,variable_name,default_value,required) VALUES ($property_id, $prod_details_block_id, $property_order, '{PROD_ACCESSORIES_MSG}: {READ_MORE_MSG}', 'RADIOBUTTON', NULL, NULL, 'accessories_more', '0', 0)";
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($property_id).", 1, 'YES_MSG', '', '1') ";
			$sqls[] = $sql;	
			$value_id++;
			$sql  = "INSERT INTO " . $table_prefix . "cms_blocks_values (value_id,property_id,value_order,value_name,variable_name,variable_value) VALUES (";
			$sql .= intval($value_id).",".intval($property_id).", 2, 'NO_MSG', '', '0') ";
			$sqls[] = $sql;	
		}
	}

	$ignore_items_shipping_cost = false; 
	$min_discounted_cost_field = false; 
	$max_discounted_cost_field = false;
	$st_image_small = false; $st_image_small_alt = false;  
	$st_image_large = false; $st_image_large_alt = false;
	$fields = $db->get_fields($table_prefix."shipping_types");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "ignore_items_shipping_cost") {
			$ignore_items_shipping_cost = true;
		} else if ($field_info["name"] == "min_discounted_cost") {
			$min_discounted_cost_field = true;
		} else if ($field_info["name"] == "max_discounted_cost") {
			$max_discounted_cost_field = true;
		} else if ($field_info["name"] == "image_small") {
			$st_image_small = true;
		} else if ($field_info["name"] == "image_small_alt") {
			$st_image_small_alt = true;
		} else if ($field_info["name"] == "image_large") {
			$st_image_large = true;
		} else if ($field_info["name"] == "image_large_alt") {
			$st_image_large_alt = true;
		}
	}
	if (!$ignore_items_shipping_cost) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN ignore_items_shipping_cost TINYINT DEFAULT '0'",
			"postgre" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN ignore_items_shipping_cost SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN ignore_items_shipping_cost BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$max_discounted_cost_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN max_discounted_cost DOUBLE(16,2) AFTER max_goods_cost ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN max_discounted_cost FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN max_discounted_cost FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$min_discounted_cost_field) {
		$sql_types = array(
			"mysql"  => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN min_discounted_cost DOUBLE(16,2) AFTER max_goods_cost ",
			"postgre"=> "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN min_discounted_cost FLOAT4 ",
			"access" => "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN min_discounted_cost FLOAT "
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$st_image_small) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN image_small VARCHAR(255) ";
	}
	if (!$st_image_small_alt) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN image_small_alt VARCHAR(255) ";
	}
	if (!$st_image_large) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN image_large VARCHAR(255) ";
	}
	if (!$st_image_large_alt) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "shipping_types ADD COLUMN image_large_alt VARCHAR(255) ";
	}

	$list_field_image = false; 
	$fields = $db->get_fields($table_prefix."filters_properties");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "list_field_image") {
			$list_field_image= true;
		}
	}
	if (!$list_field_image) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "filters_properties ADD COLUMN list_field_image VARCHAR(64) ";
	}

	$list_image = false; 
	$fields = $db->get_fields($table_prefix."filters_properties_values");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "list_image") {
			$list_image = true;
		}
	}
	if (!$list_image) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "filters_properties_values ADD COLUMN list_image VARCHAR(255) ";
	}

	// check fields for categories table
	$categories_items_types_all = false; 
	$categories_items_types_ids = false; 
	$categories_allowed_types_products = false; 
	$fields = $db->get_fields($table_prefix."categories");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "items_types_all") {
			$categories_items_types_all = true;
		} else if ($field_info["name"] == "items_types_ids") {
			$categories_items_types_ids = true;
		} else if ($field_info["name"] == "allowed_types_products") {
			$categories_allowed_types_products = true;
		}
	}

	if (!$categories_items_types_all) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_all TINYINT DEFAULT '1'",
			"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_all SMALLINT DEFAULT '1'",
			"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_all BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
		if ($categories_allowed_types_products) {
			$sqls[] = " UPDATE " . $table_prefix . "categories SET items_types_all=0 ";
			$sqls[] = " UPDATE " . $table_prefix . "categories SET items_types_all=1 WHERE allowed_types_products IS NULL OR allowed_types_products='' ";
		} else {
			$sqls[] = " UPDATE " . $table_prefix . "categories SET items_types_all=1 ";
		}
	}
	if (!$categories_items_types_ids) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_ids TEXT",
			"postgre" => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_ids TEXT",
			"access"  => "ALTER TABLE " . $table_prefix . "categories ADD COLUMN items_types_ids LONGTEXT",
		);
		$sqls[] = $sql_types[$db_type];
		if ($categories_allowed_types_products) {
			$sqls[] = " UPDATE " . $table_prefix . "categories SET items_types_ids=allowed_types_products ";
		}
	}

	// check for new profile fields
	$users_middle_name = false; $users_address3 = false;
	$fields = $db->get_fields($table_prefix."users");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "middle_name") {
			$users_middle_name = true;
		} else if ($field_info["name"] == "address3") {
			$users_address3 = true;
		}
	}
	if (!$users_middle_name) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN middle_name VARCHAR(64) AFTER first_name ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN delivery_middle_name VARCHAR(64) AFTER delivery_first_name ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN bill_middle_name VARCHAR(64) AFTER bill_first_name ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN middle_name VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN delivery_middle_name VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN bill_middle_name VARCHAR(64) ";
		}
	}
	if (!$users_address3) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN address3 VARCHAR(64) AFTER address2 ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN delivery_address3 VARCHAR(64) AFTER address2 ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN bill_address3 VARCHAR(64) AFTER address2 ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN address3 VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN delivery_address3 VARCHAR(64) ";
			$sqls[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN bill_address3 VARCHAR(64) ";
		}
	}

	// check for new profile fields
	$users_addresses_middle_name = false; $users_addresses_address3 = false;
	$fields = $db->get_fields($table_prefix."users_addresses");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "middle_name") {
			$users_addresses_middle_name = true;
		} else if ($field_info["name"] == "address3") {
			$users_addresses_address3 = true;
		}
	}
	if (!$users_addresses_middle_name) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users_addresses ADD COLUMN middle_name VARCHAR(64) AFTER first_name ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users_addresses ADD COLUMN middle_name VARCHAR(64) ";
		}
	}
	if (!$users_addresses_address3) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users_addresses ADD COLUMN address3 VARCHAR(64) AFTER address2 ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "users_addresses ADD COLUMN address3 VARCHAR(64) ";
		}
	}

	// user profile update 
	$cart_type = false; $cart_updated = false; $cart_reminder_sent = false; $cart_reminders_count = false; $cart_email_field = false; $cart_quantity_field = false;
	$cart_country_id = false; $cart_country_code = false; $cart_user_ip = false;
	$fields = $db->get_fields($table_prefix."saved_carts");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "cart_type") {
			$cart_type = true;
		} else if ($field_info["name"] == "cart_updated") {
			$cart_updated = true;
		} else if ($field_info["name"] == "reminder_sent") {
			$cart_reminder_sent = true;
		} else if ($field_info["name"] == "reminders_count") {
			$cart_reminders_count = true;
		} else if ($field_info["name"] == "cart_email") {
			$cart_email_field = true;
		} else if ($field_info["name"] == "cart_quantity") {
			$cart_quantity_field = true;
		} else if ($field_info["name"] == "country_id") {
			$cart_country_id = true;
		} else if ($field_info["name"] == "country_code") {
			$cart_country_code = true;
		} else if ($field_info["name"] == "user_ip") {
			$cart_user_ip = true;
		}
	}

	if (!$cart_type) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_type TINYINT DEFAULT '0' AFTER user_id ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_type SMALLINT DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_type BYTE ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = " UPDATE " . $table_prefix . "saved_carts SET cart_type=1 ";
	}
	if (!$cart_updated) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_updated DATETIME ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_updated TIMESTAMP ",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_updated DATETIME ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = "CREATE INDEX ".$table_prefix."saved_carts_cart_updated ON ".$table_prefix."saved_carts (cart_updated) ";
	}
	if (!$cart_reminder_sent) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminder_sent DATETIME ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminder_sent TIMESTAMP ",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminder_sent DATETIME ",
		);
		$sqls[] = $sql_types[$db_type];
		$sqls[] = "CREATE INDEX ".$table_prefix."saved_carts_reminder_sent ON ".$table_prefix."saved_carts (reminder_sent) ";
	}
	if (!$cart_reminders_count) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminders_count INT(11) DEFAULT '0' ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminders_count INT4  DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN reminders_count INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$cart_quantity_field) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_quantity INT(11) AFTER cart_name ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_quantity INT4  ",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_quantity INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$cart_email_field) {
		if ($db_type == "mysql") {
			$sqls[] = "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_email VARCHAR(128) AFTER cart_name ";
		} else {
			$sqls[] = "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN cart_email VARCHAR(128) ";
		}
	}
	if (!$cart_country_id) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN country_id INT(11) DEFAULT '0' ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN country_id INT4  DEFAULT '0'",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN country_id INTEGER ",
		);
		$sqls[] = $sql_types[$db_type];
	}
	if (!$cart_country_code) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN country_code VARCHAR(4) ";
	}
	if (!$cart_user_ip) {
		$sqls[] = "ALTER TABLE " . $table_prefix . "saved_carts ADD COLUMN user_ip VARCHAR(32) ";
	}

	$saved_items_updated_field = false; 
	$fields = $db->get_fields($table_prefix."saved_items");
	foreach ($fields as $id => $field_info) {
		if ($field_info["name"] == "date_updated") {
			$saved_items_updated_field = true;
		} 
	}
	if (!$saved_items_updated_field) {
		$sql_types = array(
			"mysql"   => "ALTER TABLE " . $table_prefix . "saved_items ADD COLUMN date_updated DATETIME ",
			"postgre" => "ALTER TABLE " . $table_prefix . "saved_items ADD COLUMN date_updated TIMESTAMP ",
			"access"  => "ALTER TABLE " . $table_prefix . "saved_items ADD COLUMN date_updated DATETIME ",
		);
		$sqls[] = $sql_types[$db_type];
	}


	if (count($sqls)) {
		$queries_success = 0; $queries_failed = 0;
		foreach ($sqls as $sql) {
			$query_result = $db->query($sql);
			if ($query_result) {
				$queries_success++;
			} else {
				$queries_failed++;
			}
		}
		$message  .= va_constant("UPGRADE_RESULTS_MSG").":<br/>";
		if ($queries_success) {
			$message .= va_constant("SQL_SUCCESS_MSG").": ".$queries_success."<br/>";
		}
		if ($queries_failed) {
			$message .= "<div class=error>".va_constant("SQL_FAILED_MSG").": ".$queries_failed."</div>";
		}
	}

	//set_session("session_upgrade", 1);


?>