// check key press events
document.onkeyup = function(evt) {
	evt = evt || window.event;
	docKeyUp(evt.keyCode);
};


function reloadBlock(pbId, htmlId, pbType)
{
	var url = "block.php?ajax=1&pb_id=" + encodeURIComponent(pbId);
	if (pbType) { url += "&pb_type=" + encodeURIComponent(pbType); }
	if (!htmlId) { htmlId = "pb_"+pbId; }
	callAjax(url, replaceBlock, htmlId);
}

function replaceBlock(blockContent, blockId)
{
	var oldBlockObj = document.getElementById(blockId);
	var parentObj = oldBlockObj.parentNode;
	var divObj = document.createElement('div'); 
	divObj.innerHTML = blockContent.trim(); 
	var newBlockObj = divObj.firstChild;
	parentObj.replaceChild(newBlockObj, oldBlockObj);
	if (newBlockObj.tagName == "LI") {
		vaNavLi(newBlockObj);
	} else {
		// check expand objects
		var jsObjs = newBlockObj.querySelectorAll("[data-js='expand']");
		for (var j = 0; j < jsObjs.length; j++) {
			vaExpandParse(jsObjs[j]);
		}
	}
	vaStopSpin(blockId);
}

function showMessageBlock(msgType, msgText, controlId)
{
	// delete popup block if it was initialized before
	hideMessageBlock();

	var controlObj = document.getElementById(controlId);
	var pageSize = getPageSize()
	var popupObj = document.createElement("div");
	popupObj.id = "messageBlock";
	if (msgType == "error") {
		popupObj.className = "errorbg";
	} else {
		popupObj.className = "messagebg";
	}

	popupObj.style.zIndex = "999";
	popupObj.style.position = "absolute";
	popupObj.style.border = "1px solid #CED7DF";
	popupObj.style.background= "#FFFFFF";
	popupObj.style.padding = "5px";
	popupObj.style.width = "300px";
	popupObj.style.whiteSpace = "normal";
	popupObj.style.textAlign = "left";
	popupObj.style.cursor = "pointer";
	popupObj.onclick = function() { hideMessageBlock(); };

	if (controlObj) {
		var msgLeft = findPosX(controlObj);
		var msgTop = findPosY(controlObj, true);
		popupObj.style.left = msgLeft+"px";
		popupObj.style.top  = msgTop+"px";
	} else {
		popupObj.style.left = pageSize[0]/2 - 150 + "px";
		popupObj.style.top  = pageSize[1]/2 - 20 + "px";
	}

	popupObj.innerHTML = msgText;
	document.body.insertBefore(popupObj, document.body.firstChild);
}


function showPopupBlock(msg)
{
	if (msg.match(/^[a-z0-9\-\_]+$/) ) {
		if (document.getElementById(msg)) {
			msg = document.getElementById(msg).innerHTML;
		}
	}

	// delete popup block if it was initialized before
	hidePopupFrame();

	var pageSize = getPageSize()

	// add popup area
	var areaObj = document.createElement("div");
	areaObj.id = "popupArea";
	areaObj.className = "popup-area";
	document.body.insertBefore(areaObj, document.body.firstChild);

	var popupObj = document.getElementById("popupBlock");
	if (popupObj) {
		var popupBody = popupObj.querySelector(".popup-body");
		popupBody.innerHTML = msg;
		popupObj.style.display = "block";

		// move popup to the center
		var popupWidth = popupObj.offsetWidth;
		var popupHeight = popupObj.offsetHeight
		var popupLeft = (pageSize[0] - popupWidth)/2;
		var popupTop = (pageSize[1] - popupHeight)/2;
		if (popupLeft < 0) { popupLeft = 0; }
		if (popupTop < 0) { popupTop = 0; }
		// if page was scrolled move popup window to scrolled height
		if (document.body.scrollTop || document.documentElement.scrollTop) {
			popupTop += (document.body.scrollTop || document.documentElement.scrollTop);
		}
  
		popupObj.style.left = popupLeft + "px";
		popupObj.style.top = popupTop + "px";

	} else {
		areaObj.innerHTML = msg;
	}
/*
<div id="blockPopup" class="bk-popup">
	<div class="popup-header">
		<div class="popup-close" onclick="hidePopupBlock();">Close Window<img src="images/icons/frame-close.gif" width="19" height="19" align="top" /></div>
		<div class="popup-title"></div>
	</div>

	<div class="popup-body">

	</div>
</div>

	popupObj.innerHTML = msg;
*/
/*

*/

}

function hidePopupBlock()
{
	var popupArea = document.getElementById("popupArea");
	if (popupArea) {
		var parentObj = popupArea.parentNode;
		parentObj.removeChild(popupArea);
	}
	var popupObj = document.getElementById("popupBlock");
	if (popupObj) {
		popupObj.style.display = "none";
	}
}

function showPopupFrame(msgText)
{
	// delete popup block if it was initialized before
	hidePopupFrame();

	var pageSize = getPageSize()
	var popupObj = document.createElement("div");
	popupObj.id = "popupArea";
	popupObj.className = "popupArea";
	popupObj.style.zIndex = "111";
	popupObj.style.position = "absolute";
	popupObj.style.left = "0px";
	popupObj.style.top = "0px";
	popupObj.style.backgroundColor = "rgba(0, 0, 0, 0.6)";
	popupObj.innerHTML = msgText;
	document.body.insertBefore(popupObj, document.body.firstChild);
	// check size for shadow background
	var fullSize = getPageSizeWithScroll();
	popupObj.style.width = fullSize[0]+"px";
	popupObj.style.height = fullSize[1]+"px";

	// move frame to the center
	var popupFrame = document.getElementById("popupFrame");
	var frameWidth = popupFrame.offsetWidth;
	var frameHeight = popupFrame.offsetHeight
	var frameLeft = (pageSize[0] - frameWidth)/2;
	var frameTop = (pageSize[1] - frameHeight)/2;
	if (frameLeft < 0) { frameLeft = 0; }
	if (frameTop < 0) { frameTop = 0; }
	// if page was scrolled move popup window to scrolled height
	if (document.body.scrollTop || document.documentElement.scrollTop) {
		frameTop += (document.body.scrollTop || document.documentElement.scrollTop);
	}

	popupFrame.style.left = frameLeft + "px";
	popupFrame.style.top = frameTop + "px";

}

function hidePopupFrame()
{
	var popupObj = document.getElementById("popupArea");
	if (popupObj) {
		var parentObj = popupObj.parentNode;
		parentObj.removeChild(popupObj);
	}
}


function hideMessageBlock()
{
	var messageObj = document.getElementById("messageBlock");
	if (messageObj) {
		var parentObj = messageObj.parentNode;
		parentObj.removeChild(messageObj);
	}
}


function docKeyUp(keyCode)
{
	if (keyCode == 27) {
		var messageObj = document.getElementById("messageBlock");
		var popupObj = document.getElementById("popupArea");
		if (messageObj) {
			var parentObj = messageObj.parentNode;
			parentObj.removeChild(messageObj);
		} else if (popupObj) {
			var parentObj = popupObj.parentNode;
			parentObj.removeChild(popupObj);
		}
		var popupObj = document.getElementById("popupBlock");
		if (popupObj) {
			popupObj.style.display = "none";
		}
		var blackCloudObj = document.getElementById("black_cloud");
		if (blackCloudObj ) {
			hideBlack();
		}
	}
}